Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.lang3.text
Class StrLookup<V>

    java.lang.Object
      org.apache.commons.lang3.text.StrLookup<V>

    public abstract class StrLookup<V>

extends Object

Lookup a String key to a String value.

This class represents the simplest form of a string to string map. It has a benefit over a map in that it can create the result on demand based on the key.

This class comes complete with various factory methods. If these do not suffice, you can subclass and implement your own matcher.

For example, it would be possible to implement a lookup that used the key as a primary key, and looked up the value on demand from the database

Since:
  2.2
Version:
  $Id: StrLookup.java 899933 2010-01-16 12:53:54Z sebb $
Author:
  Apache Software Foundation

Constructor Summary
`protected` | `StrLookup()` Constructor.

Method Summary
`abstract String` | `lookup(String key)` Looks up a String key to a String value.
`static
`<V> StrLookup<V>`
` | `mapLookup(Map<String,V> map)` Returns a lookup which looks up values using a map.
`static StrLookup<?>` | `noneLookup()` Returns a lookup which always returns null.
`static StrLookup<String>` | `systemPropertiesLookup()` Returns a lookup which uses `System properties` to lookup the key to value.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StrLookup

    protected StrLookup()

  Constructor.

Method Detail

### noneLookup

    public static StrLookup<?> noneLookup()

  Returns a lookup which always returns null.

  Returns:
    a lookup that always returns null, not null

### systemPropertiesLookup

    public static StrLookup<String> systemPropertiesLookup()

  Returns a lookup which uses `System properties` to lookup the key to value.

  If a security manager blocked access to system properties, then null will be returned from every lookup.

  If a null key is used, this lookup will throw a NullPointerException.

  Returns:
    a lookup using system properties, not null

### mapLookup

    public static <V> StrLookup<V> mapLookup(Map<String,V> map)

  Returns a lookup which looks up values using a map.

  If the map is null, then null will be returned from every lookup. The map result object is converted to a string using toString().

  Parameters:
    `map` - the map of keys to values, may be null
  Returns:
    a lookup using the map, not null

### lookup

    public abstract String lookup(String key)

  Looks up a String key to a String value.

  The internal implementation may use any mechanism to return the value. The simplest implementation is to use a Map. However, virtually any implementation is possible.

  For example, it would be possible to implement a lookup that used the key as a primary key, and looked up the value on demand from the database Or, a numeric based implementation could be created that treats the key as an integer, increments the value and return the result as a string - converting 1 to 2, 15 to 16 etc.

  The `lookup(String)` method always returns a String, regardless of the underlying data, by converting it as necessary. For example:

       Map map = new HashMap();
       map.put("number", new Integer(2));
       assertEquals("2", StrLookup.mapLookup(map).lookup("number"));

  Parameters:
    `key` - the key to be looked up, may be null
  Returns:
    the matching value, null if no match

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2010 The Apache Software Foundation. All Rights Reserved.